



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android 热修复技术（1）---原理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android 热修复技术（1）---原理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 17:54:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>热修复技术分为几部分：</p>
<p>原理介绍</p>
<p>Android HotFix源码分析</p>
<p>自定义框架</p>
<h3>1.Android分包MultiDex原理</h3>
<p>首先Dex是什么东西？</p>
<p>Dex就是Window里面的exe文件 也就是可执行问题。</p>
<p>Android没有用传统的Java虚拟机，而是使用dalvik虚拟机。当APK安装到手机后，dalvik会先把de文件转化位ODEX文件，</p>
<p>优化结构。</p>
<p>在早期的android系统中，为了优化dex，所有的method会存放在一张表里面，表的大小位short，也就是65535（65K）</p>
<p>But现在android代码非常多，超过65K很正常，这个时候就需要一种解决方案来解决这个问题。</p>
<p>简单来说就是将编译好的class文件分拆成2个dex文件，绕过65k的限制。</p>
<p>关于分包的具体实现，可以参考<a href="http://blog.csdn.net/gaozhan_csdn/article/details/51992100" rel="external nofollow noreferrer">dex分包方案概述与multidex包的配置使用</a></p>
<h3>2.Android热补丁修复技术原理</h3>
<p>目的：有时候需要修改几行代码，但是我们需要重发各个市场，重新release等。是不是可以只是简单的打patch就可以解决这个问题呢？</p>
<p>首先来看dex加载的源码：</p>
<div>
<pre class="prettyprint linenums">public Class findClass(String name, List&lt;Throwable&gt; suppressed) {<br />
    for (Element element : dexElements) {<br />
        DexFile dex = element.dexFile;

        if (dex != null) {<br />
            Class clazz = dex.loadClassBinaryName(name, definingContext, suppressed);<br />
            if (clazz != null) {<br />
                return clazz;<br />
            }<br />
        }<br />
    }<br />
    if (dexElementsSuppressedExceptions != null) {<br />
        suppressed.addAll(Arrays.asList(dexElementsSuppressedExceptions));<br />
    }<br />
    return null;<br />
}</pre>
</div>
<p>每个element对应的就是dex文件，所以加载class就是从一个个dex文件中找到对应的code。but，可以发现，一旦找到成功了以后，就直接return。</p>
<p>也就是说如果2个dex含有相同的class，会先返回前面那个。</p>
<p>so 我们的解决方案来了，使用一个新的dex，让他在element文件表的最前面，这样我们修改的class文件就会被首先加载进来。</p>
<p>理论上，如果在不同的dex中有相同的类存在，那么会优先选择排在前面的dex文件的类，如下图：</p>
<p><img referrerpolicy="no-referrer"src="http://mmbiz.qpic.cn/mmbiz/0aYRVN1mAJwR6vqR4Yv6V3zIvjqmgdu7dVfrXN7XxhOjiaahHricl00hal4rjw1cQ2LRFKVGU7uUOO0Q5HSz7hKw/640?wx_fmt=png&amp;tp=webp&amp;wxfrom=5&amp;wx_lazy=1" data-src="http://mmbiz.qpic.cn/mmbiz/0aYRVN1mAJwR6vqR4Yv6V3zIvjqmgdu7dVfrXN7XxhOjiaahHricl00hal4rjw1cQ2LRFKVGU7uUOO0Q5HSz7hKw/0?wx_fmt=png" /><br />        在此基础上，我们构想了热补丁的方案，把有问题的类打包到一个dex（patch.dex）中去，然后把这个dex插入到Elements的最前面，如下图：</p>
<p><img referrerpolicy="no-referrer"src="http://mmbiz.qpic.cn/mmbiz/0aYRVN1mAJwR6vqR4Yv6V3zIvjqmgdu7L1OTRicUdpKy3Txd5eancPZXSWKVic4S9A7rUticj9aKY5UhfbAhjpLjg/640?wx_fmt=png&amp;tp=webp&amp;wxfrom=5&amp;wx_lazy=1" data-src="http://mmbiz.qpic.cn/mmbiz/0aYRVN1mAJwR6vqR4Yv6V3zIvjqmgdu7L1OTRicUdpKy3Txd5eancPZXSWKVic4S9A7rUticj9aKY5UhfbAhjpLjg/0?wx_fmt=png" /></p>
<p>好，该方案基于第二个拆分dex的方案，方案实现如果懂拆分dex的原理的话，大家应该很快就会实现该方案，如果没有拆分dex的项目的话，可以参考一下谷歌的multidex方案实现。然后在插入数组的时候，把补丁包插入到最前面去。</p>
<p>But 我们发现在插入patch.dex后，会报错，原因是CLASS_ISPREVERIFIED。这是个什么东东？</p>
<p>在类的方法中直接引用的类，如果在同一dex中，就会被打上CLASS_ISPREVERIFIED这个标志。</p>
<p>我们单独给一个AntilazyLoad类打包成hack.dex 这样每个class里面都调用。我们在构造函数里面添加：</p>
<div>
<pre class="prettyprint linenums">public class A{<br />
    public A（）<br />
    {<br />
        system.println(AntilazyLoad.class);<br />
    }<br />
}</pre>
</div>
<p>So,这样A就引用了不在一个dex里面的class，从而不会被打上CLASS_ISPREVERIFIED的代码。进而不会出现问题。</p>
<p>参考：</p>
<p><a href="https://mp.weixin.qq.com/s?__biz=MzI1MTA1MzM2Nw==&amp;mid=400118620&amp;idx=1&amp;sn=b4fdd5055731290eef12ad0d17f39d4a&amp;scene=1&amp;srcid=1106Imu9ZgwybID13e7y2nEi#wechat_redirect" rel="external nofollow noreferrer">安卓App热补丁动态修复技术介绍</a></p>
<p>http://my.oschina.net/853294317/blog/308583</p>
<p>http://blog.csdn.net/lmj623565791/article/details/49883661</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwv1w38.html">Entity Framework 6 开发系列 目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ow1l59.html">Emacs配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j6eg4q.html">南阳理工 题目9&colon;posters（离散化&plus;线段树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvlwg18.html">uniGUI试用笔记（十三）调用WebService</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x0wdv8.html">XAMPP Apache 配置多端口和多域名方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv2x1zq.html">git和svn的区别001</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdydgr8.html">Android Studio 学习 - 基本控件的使用；Intent初学</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd0v4y8.html">archlinux  locale-gen 命令出错</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd754e8.html">Iwpriv工作流程及常用命令使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x123r9.html">Linux软件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvyxxyq.html">mysql命令行执行外部文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/950x6d68.html">Cocos2d-X研究之v3&period;x瓦片地图具体解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljolk19.html">subnetting and the subnet mask</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojvxelq.html">java类初始化，使用构造方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1yknxq.html">『动态』动态JSON万能转换函数 &plus; &period;Net40 dynamic动态数据绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwo3y09.html">Linux进程管理工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2d27d8.html">Lotus Domino和关系型数据库&lpar;LEI&comma;DESC&comma;JDBC连接&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjwj7zq.html">Javascript Get or Set Checked Radio Value</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvezlm19.html">VSS&lowbar;01</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvepllj9.html">CALayer的position&comma;anchorPoint属性 与UIView的frame 属性</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/0qwveo38.html">Linux内存管理之bootmem分配器</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqll2r1q.html">II7&period;0 发布 MVC 4&period;0 三个小问题记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7oylx8.html">Spinner控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwvmr38.html">FineUI Grid控件高度自适应</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93w4rnq.html">jQuery-1&period;9&period;1源码分析系列（十） 事件系统&mdash;&mdash;事件委托</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93w45gq.html">TCP的阻塞和重传机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/390rgzn9.html">Keil环境中建立带FreeRTOS的STM32L项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7okve8.html">C&num;入门经典Lambda</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gj2249.html">Win10 IoT C&num;开发 4 - UART 串口通信</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jmjne9.html">java实现链表</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
